'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _get = require('babel-runtime/helpers/get')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

_Object$defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = createObservableComponent;

var _react = require('react');

var _rx = require('rx');

var _rx2 = _interopRequireDefault(_rx);

function createObservableComponent(componentFunction) {
  return (function (_Component) {
    function ObservableComponent() {
      _classCallCheck(this, ObservableComponent);

      _get(Object.getPrototypeOf(ObservableComponent.prototype), 'constructor', this).call(this);

      this.subscribtion = null;
      this.vtree = null;
      this.shouldRefresh = true;
    }

    _inherits(ObservableComponent, _Component);

    _createClass(ObservableComponent, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.refresh(this.props);
      }
    }, {
      key: 'componentWillUpdate',
      value: function componentWillUpdate(nextProps) {
        if (this.shouldRefresh) {
          this.dispose();
          this.refresh(nextProps);
        } else {
          this.shouldRefresh = true;
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.dispose();
      }
    }, {
      key: 'forceUpdateWithoutRefresh',
      value: function forceUpdateWithoutRefresh() {
        this.shouldRefresh = false;
        this.forceUpdate();
      }
    }, {
      key: 'refresh',
      value: function refresh(props) {
        var _this = this;

        var vtreeOrObservable = componentFunction(props);
        var insideLifecycle = true;

        if (vtreeOrObservable instanceof _rx2['default'].Observable) {
          this.vtree = null;
          this.subscribtion = vtreeOrObservable.subscribe(function (vtree) {
            _this.vtree = vtree;

            if (!insideLifecycle) {
              _this.forceUpdateWithoutRefresh();
            }
          }, function (error) {
            throw error;
          });
        } else {
          this.vtree = vtreeOrObservable;
        }

        insideLifecycle = false;
      }
    }, {
      key: 'dispose',
      value: function dispose() {
        if (this.subscribtion) {
          this.subscribtion.dispose();
          this.subscribtion = null;
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return this.vtree;
      }
    }], [{
      key: 'displayName',
      value: componentFunction.name,
      enumerable: true
    }]);

    return ObservableComponent;
  })(_react.Component);
}

module.exports = exports['default'];